/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.tarifas;

import com.rjconsultores.ventaboletos.entidad.ClaseServicio;
import com.rjconsultores.ventaboletos.entidad.Marca;
import com.rjconsultores.ventaboletos.entidad.OrgaoConcedente;
import com.rjconsultores.ventaboletos.entidad.Parada;
import com.rjconsultores.ventaboletos.entidad.Plaza;
import com.rjconsultores.ventaboletos.entidad.TarifaMinima;
import com.rjconsultores.ventaboletos.service.ClaseServicioService;
import com.rjconsultores.ventaboletos.service.MarcaService;
import com.rjconsultores.ventaboletos.service.OrgaoConcedenteService;
import com.rjconsultores.ventaboletos.service.ParadaService;
import com.rjconsultores.ventaboletos.service.PlazaService;
import com.rjconsultores.ventaboletos.service.TarifaMinimaService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderTarifaMinima;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zhtml.Messagebox;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Combobox;
import org.zkoss.zul.Paging;

/**
 *
 * @author rodrigo
 */
@Controller("busquedaTarifasMinimasController")
@Scope("prototype")
public class BusquedaTarifasMinimasController extends MyGenericForwardComposer {

    @Autowired
    private transient PagedListWrapper<TarifaMinima> plwTarifaMinima;
    @Autowired
    private MarcaService marcaService;
    @Autowired
    private ParadaService paradaService;
    @Autowired
    private ClaseServicioService claseServicioService;
    @Autowired
    private TarifaMinimaService tarifaMinimaService;
    @Autowired
    private PlazaService plazaService;
    @Autowired
	private OrgaoConcedenteService orgaoConcedenteService;
    private List<Marca> lsMarcas;
    private List<ClaseServicio> lsClaseServico;
    private List<OrgaoConcedente> lsOrgaoConcedente;
    private List<Plaza> lsPlaza;
    private MyListbox tarifaMinimaList;
    private Paging pagingTarifaMinima;
    private Combobox cmbMarca;
    private Combobox cmbOrigem;
    private Combobox cmbDestino;
    private Combobox cmbClaseServicio;
    private Combobox cmbOrgaoConcedente;

    public Combobox getCmbClaseServicio() {
        return cmbClaseServicio;
    }

    public void setCmbClaseServicio(Combobox cmbClaseServicio) {
        this.cmbClaseServicio = cmbClaseServicio;
    }

    public Combobox getCmbDestino() {
        return cmbDestino;
    }

    public void setCmbDestino(Combobox cmbDestino) {
        this.cmbDestino = cmbDestino;
    }

    public List<Plaza> getLsPlaza() {
        return lsPlaza;
    }

    public void setLsPlaza(List<Plaza> lsPlaza) {
        this.lsPlaza = lsPlaza;
    }

    public Combobox getCmbMarca() {
        return cmbMarca;
    }

    public void setCmbMarca(Combobox cmbMarca) {
        this.cmbMarca = cmbMarca;
    }

    public Combobox getCmbOrigem() {
        return cmbOrigem;
    }

    public void setCmbOrigem(Combobox cmbOrigem) {
        this.cmbOrigem = cmbOrigem;
    }

    public Paging getPagingTarifaMinima() {
        return pagingTarifaMinima;
    }

    public void setPagingTarifaMinima(Paging pagingTarifaMinima) {
        this.pagingTarifaMinima = pagingTarifaMinima;
    }

    public PagedListWrapper<TarifaMinima> getPlwTarifaMinima() {
        return plwTarifaMinima;
    }

    public void setPlwTarifaMinima(PagedListWrapper<TarifaMinima> plwTarifaMinima) {
        this.plwTarifaMinima = plwTarifaMinima;
    }

    public MyListbox getTarifaMinimaList() {
        return tarifaMinimaList;
    }

    public void setTarifaMinimaList(MyListbox tarifaMinimaList) {
        this.tarifaMinimaList = tarifaMinimaList;
    }

    public List<ClaseServicio> getLsClaseServico() {
        return lsClaseServico;
    }

    public void setLsClaseServico(List<ClaseServicio> lsClaseServico) {
        this.lsClaseServico = lsClaseServico;
    }

    public List<Marca> getLsMarcas() {
        return lsMarcas;
    }

    public void setLsMarcas(List<Marca> lsMarcas) {
        this.lsMarcas = lsMarcas;
    }

    public void onClick$btnPesquisa(Event ev) throws InterruptedException {
        refreshLista();
    }

    public void onClick$btnRefresh(Event ev) {
        refreshLista();
    }

    public void onClick$btnNovo(Event ev) {
        verTarifaMinima(new TarifaMinima());
    }

    public List<OrgaoConcedente> getLsOrgaoConcedente() {
		return lsOrgaoConcedente;
	}

	public void setLsOrgaoConcedente(List<OrgaoConcedente> lsOrgaoConcedente) {
		this.lsOrgaoConcedente = lsOrgaoConcedente;
	}

	public Combobox getCmbOrgaoConcedente() {
		return cmbOrgaoConcedente;
	}

	public void setCmbOrgaoConcedente(Combobox cmbOrgaoConcedente) {
		this.cmbOrgaoConcedente = cmbOrgaoConcedente;
	}

	@Override
    public void doAfterCompose(Component comp) throws Exception {
        super.doAfterCompose(comp);

        tarifaMinimaList.setItemRenderer(new RenderTarifaMinima());
        tarifaMinimaList.addEventListener("onDoubleClick", new EventListener() {

            @Override
            public void onEvent(Event event) throws Exception {
                TarifaMinima tf = (TarifaMinima) tarifaMinimaList.getSelected();
                verTarifaMinima(tf);
            }
        });

        lsMarcas = marcaService.buscarMarcaPorEmpresa(UsuarioLogado.getUsuarioLogado().getEmpresa());
        lsOrgaoConcedente = orgaoConcedenteService.obtenerTodos();

        lsClaseServico = new ArrayList<ClaseServicio>();
        lsClaseServico.add(null);
        lsClaseServico.addAll(claseServicioService.obtenerTodos());

        lsPlaza = new ArrayList<Plaza>();
        lsPlaza.add(null);
        lsPlaza.addAll(plazaService.obtenerTodos());

        refreshLista();
    }

    private void verTarifaMinima(TarifaMinima tf) {
        if (tf == null) {
            return;
        }

        Map args = new HashMap();
        args.put("tarifaMinima", tf);
        args.put("tarifaMinimaList", tarifaMinimaList);

        openWindow("/gui/tarifas/editarTarifasMinimas.zul",
                Labels.getLabel("editarTarifaMinimaController.window.title"), args, MODAL);
    }

    private void refreshLista() {
        HibernateSearchObject<TarifaMinima> tarifaMinimaBusqueda =
                new HibernateSearchObject<TarifaMinima>(TarifaMinima.class, pagingTarifaMinima.getPageSize());
        tarifaMinimaBusqueda.addFilterEqual("activo", Boolean.TRUE);

        OrgaoConcedente orgaoConcedente = (OrgaoConcedente) (cmbOrgaoConcedente.getSelectedItem() != null ? cmbOrgaoConcedente.getSelectedItem().getValue() : null);
        if (orgaoConcedente != null) {
            tarifaMinimaBusqueda.addFilterEqual("orgaoConcedente", orgaoConcedente);
        }
        
        Parada origem = (Parada) (cmbOrigem.getSelectedItem() != null ? cmbOrigem.getSelectedItem().getValue() : null);
        if (origem != null) {
            tarifaMinimaBusqueda.addFilterEqual("origem", origem);
        }
        Parada destino = (Parada) (cmbDestino.getSelectedItem() != null ? cmbDestino.getSelectedItem().getValue() : null);
        if (destino != null) {
            tarifaMinimaBusqueda.addFilterEqual("destino", destino);
        }
        Marca marca = (Marca) (cmbMarca.getSelectedItem() != null ? cmbMarca.getSelectedItem().getValue() : null);
        if (marca != null) {
            tarifaMinimaBusqueda.addFilterEqual("marca", marca);
        }else{
        	tarifaMinimaBusqueda.addFilterIn("marca", lsMarcas);
        }
        ClaseServicio claseServicio = (ClaseServicio) (cmbClaseServicio.getSelectedItem() != null ? cmbClaseServicio.getSelectedItem().getValue() : null);
        if (claseServicio != null) {
            tarifaMinimaBusqueda.addFilterEqual("claseServicio", claseServicio);
        }

        plwTarifaMinima.init(tarifaMinimaBusqueda, tarifaMinimaList, pagingTarifaMinima);

        if (tarifaMinimaList.getData().length == 0) {
            try {
                Messagebox.show(Labels.getLabel("MSG.ningunRegistro"),
                        Labels.getLabel("busquedaTarifasMinimasController.window.title"),
                        Messagebox.OK, Messagebox.INFORMATION);
            } catch (InterruptedException ex) {
            }
        }
    }

    
}
